#!/bin/sh
#
# ! Many thanks to Kindzadza, Ronald and Dr.Matrix for writing		!
# ! great EMU software and by doing so making Linux based receivers 	|
# ! the best in the world. Hope you guys continue to extend and improve ! 
# ! your software for a long time! Thanks!				!
#
# dreamconv.sh - convert between several emu key formats
#
# History:
# v2.3.6 - 27-11-2003 
# - fixed: scce conversions (paths to files)
# - added: creation destination file from some sources (one for each scrambling system)
#   Press menu option for selecting mode:
#   all systems					        - all conversions creates destination files with keys for all scrambling systems
#   init key files for modes: 	        - the conversion will create empty destination file
#   append only irdeto/seca/via/nagra	- all next will append keys for selected scrambling system
#
# v2.3.5 - 18-11-2003 - Tom0000
# - added: conversion from mgcamd to camd3 (camd.key)
# - added: conversion from camd3 to mgcamd
# - fixed: newcamd functions
#
# v2.3.4 - 14-11-2003 - Tom0000
#  - added: conversion from softcam.key to scce
#  - fixed: conversion from scce->softcam.key, gbox->scce, scce->gbox
#
# v2.3.3 - 07-11-2003 - Tom0000
#  - added: conversion from keylist (newcamd) to softcam.key
#  - added: conversion from softcam.key to keylist (newcamd)
#      If you will find a bug, write about it: cattomcat@hotmail.com
#
# v2.3.2 - 07-11-2003 - Tom0000
#  - added: conversion from keys.txt (xcam) to softcam.key
#  - added: conversion from Keylist.txt (evocamd) to softcam.key
#  - added: conversion from softcam.key to Keylist.txt (evocamd)
#
# v2.3.1 - 23-10-2003 - Tom0000
# - added: conversion from gbox to softcam.key
# - fixed: conversion from softcam.key to gbox
#
# v2.3.0 - 23-08-2003 - noleech
# - added: romu key conversion (for now same as scce)
# - added: nozap key conversion (use mgcamd2romu with CardManie SoftCam.Key)
# - fixed: comments are converted again to x2romu, ROMU rules ;-)
# - fixed: gbox2emu Viaccess PMK conversion UNTESTED
#
# v2.2.2 - 29-05-2003 - noleech
# - rewrote mgcamd --> gbox nagra provider id hack
# - added star digital provider id hack
#
# v2.2.1 - 21-05-2003 - noleech
# - Thanks to MikeV@sat4all for testing!
# - added gbox <-> scce irdeto/seca/via pmk key conversion 
#   (not 100% sure about format and whether scce supports it yet)
# - fixed mgcamd/gbox --> scce now deletes all comment 
#   (otherwise scce complains about illegal characters)
#
# v2.1.1 - 18-05-2003 - noleech
# - fixed broken via_keys output in mgcamd2scce and gbox2scce
#
# v2.0 - 17-05-2003 - noleech
# - added mgcamd --> scce :)
# - added mgcamd --> gbox
# - added added nagravision provider hack
# - added nagra to gbox <-> scce
# - namechange to dreamconv.sh
# - added lots of comment
#
# v1.0 - 15-05-2003 - noleech
# - (called keyconvert.sh) initial version gbox <-> scce
# 
# o0O todo O0o
# - todo:  mgcamd2romu au lines?
# - todo:  file converted from $file at $date
#
#
# MAKE SURE THE FOLLOWING PATHS ARE CORRECT!
#
# define the path and filenames of gbox keyfiles
GBOXIRDETO=/var/keys/irdeto
GBOXIRDETOTMP=/tmp/irdeto
GBOXNAGRA=/var/keys/nagra
GBOXNAGRATMP=/tmp/nagra
GBOXSECA=/var/keys/seca
GBOXSECATMP=/tmp/seca
GBOXVIA=/var/keys/via
GBOXVIATMP=/tmp/via
GBOXCONAX=/var/keys/conax
GBOXCONAXTMP=/tmp/conax

# define the path and filenames of scce keyfiles
SCCECONAX=/var/scce/conax_keys
SCCECONAXTMP=/tmp/conax_keys
SCCEIRDETO=/var/scce/irdeto_keys
SCCEIRDETOTMP=/tmp/irdeto_keys
SCCENAGRA=/var/scce/nagra_keys
SCCENAGRATMP=/tmp/nagra_keys
SCCENOZAP=/var/scce/nozap_keys
SCCENOZAPTMP=/tmp/nozap_keys
SCCESECA=/var/scce/seca_keys
SCCESECATMP=/tmp/seca_keys
SCCEVIA=/var/scce/via_keys
SCCEVIATMP=/tmp/via_keys
SCCENAGRARSA=/var/scce/nagra_rsa

# define path and filename of mgcamd keyfile
MGCAMD=/var/keys/SoftCam.Key
MGCAMDTMP=/tmp/SoftCam.Key
XCAM=/var/keys/keys.txt
XCAMTMP=/tmp/keys.txt
EVOCAMD=/var/keys/Keylist.txt
EVOCAMDTMP=/tmp/Keylist.txt
NEWCAMD=/var/scce/keylist
NEWCAMDTMP=/tmp/keylist
CAMD3=/var/keys/camd.key
CAMD3TMP=/tmp/camd.key

# define path and filename of mgcamd irdeto pmk/nagra rsa file
AUTOROLL=/var/keys/AutoRoll.Key

#MGCAMD=/var/keys/SoftCam.Key
#AUTOROLL=/var/keys/AutoRoll.Key

getconvertmode()
{
#all        : 9
#none       : 0
#only       : irdeto(=1),via(=2),seca(=3),nagra(=4),conax(=5) 
	if [ -e /tmp/convertmode ] ; then
		CONVERTMODE=`cat 2>/dev/null /tmp/convertmode`
	else
		CONVERTMODE=9
	fi
}

setconvertmode()
{
	echo "$1" > /tmp/convertmode
	CONVERTMODE=$1
}

andthemodeis()
{
CORRECTMODE=0;
case $1 in
  init)
	if [ ${CONVERTMODE} = 0 -o ${CONVERTMODE} = 9 ] ; then
	  CORRECTMODE=1
	fi
	;;
  irdeto)
	if [ ${CONVERTMODE} = 9 -o ${CONVERTMODE} = 1 ]; then
	  CORRECTMODE=1
	fi
	;;
  via)
	if [ ${CONVERTMODE} = 9 -o ${CONVERTMODE} = 2 ]; then
	  CORRECTMODE=1
    fi
	;;
  seca)
	if [ ${CONVERTMODE} = 9 -o ${CONVERTMODE} = 3 ]; then
	  CORRECTMODE=1
	fi
	;;
  nagra)
	if [ ${CONVERTMODE} = 9 -o ${CONVERTMODE} = 4 ]; then
	  CORRECTMODE=1
	fi
	;;
  conax)
	if [ ${CONVERTMODE} = 9 -o ${CONVERTMODE} = 5 ]; then
	  CORRECTMODE=1
	fi
	;;
esac
}


gbox2scce()
{
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[MI]:' $GBOXIRDETOTMP | sed -e 's/^M: { \(..\) \(..\) \(..\) \(.*\)/M: { \1\2\3 \4/' > $SCCEIRDETO
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && grep -e '^N:' $GBOXNAGRATMP | sed -e 's/^N: { \(..\) \(..\) \(.*\)/N: { \1\2 \3/' > $SCCENAGRA
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[MS]:' $GBOXSECATMP | sed -e 's/^S: { \(..\) \(.*\)/S: { \1\2/' -e 's/^M: { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(.*\)/M: { \1\2 \4\5\6 \7 \8/' > $SCCESECA
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '[MV]:' $GBOXVIATMP | sed -e 's/^M: { \(.\)\(.\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/M: { \2\3\4 \6\7\8/' -e 's/^M: { \(.....\) \(......\)\(..\)\(...\)\(.*\)/M: { \1 \2 \3\5/' -e 's/^V: { \(..\) \(..\) \(.\)\(.\) \(..\)\(.*\)/V: { \1\2\3 \5\6/' > $SCCEVIA
}

scce2gbox()
{
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[MI;]' $SCCEIRDETO | sed -e 's/^M: { \(..\)\(..\)\(..\)/M: { \1 \2 \3/' -e 's/^;/#/'  > $GBOXIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXIRDETOTMP $GBOXIRDETO
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && grep -e '^[N;]' $SCCENAGRA | sed -e 's/^N: { \(..\)\(..\) \(.*\)/N: { \1 \2 \3/' -e 's/^;/#/' > $GBOXNAGRATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXNAGRATMP $GBOXNAGRA
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[MS;]' $SCCESECA | sed -e 's/^S: { \(..\)\(.*\)/S: { \1 \2/' -e 's/^M: { \(..\)\(..\) \(..\)\(..\)\(..\) \(..\)\(.*\)/M: { \1 \2 00 \3 \4 \5 \6\7/' -e 's/^;/#/' > $GBOXSECATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXSECATMP $GBOXSECA
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[MV;]' $SCCEVIA | sed -e 's/^V: { \(..\)\(..\)\(.\) \(.*\)/V: { \1 \2 \30 \4/' -e 's/^M: { \(..\)\(..\)\(..\) \(..\)\(..\)\(..\)\(.*\)/M: { 00 \1 \2 \3 00 \4 \5 \6\7/' -e 's/^;/#/' > $GBOXVIATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXVIATMP $GBOXVIA
}

mgcamd2gbox()
{
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && echo "# Irdeto gbox file generated by dreamconv.sh from SoftCam.Key" > $GBOXIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXIRDETO >> $GBOXIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] .. ' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/I: \{ \2 \{ \3 \4 \5 \6 \7 \8 \9 /' -e 's/^I: \({ .. { .. .. .. .. .. .. .. \)\(..\)/I: \1\2 }}/' -e 's/^I: { \(.. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/I: { \1\2/' >> $GBOXIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXIRDETOTMP $GBOXIRDETO
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && echo "# Nagra gbox file generated by dreamconv.sh from SoftCam.Key" > $GBOXNAGRATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXNAGRA >> $GBOXNAGRATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $MGCAMD | sed -e 's/^[Nn] \(..\)\(..\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/N: { \1 \2 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^N: { \(.. .. .. { .. .. .. .. .. ..\) \(..\)\(..\)/N: { \1 \2 \3 }}/' -e 's/^N: { \(.. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/N: { \1\2/' >> $GBOXNAGRATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXNAGRATMP $GBOXNAGRA
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && echo "# Seca gbox file generated by dreamconv.sh from SoftCam.Key" > $GBOXSECATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXSECA >> $GBOXSECATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $MGCAMD | sed -e 's/^[Ss] \(..\)\(..\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/S: { \1 \2 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^S: { \(.. .. .. { .. .. .. .. .. .. \)\(..\)\(..\)/S: { \1\2 \3 }}/' -e 's/^S: { \(.. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/S: { \1\2/' >> $GBOXSECATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXSECATMP $GBOXSECA
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && echo "# Viaccess gbox file generated by dreamconv.sh from SoftCam.Key" > $GBOXVIATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXVIA >> $GBOXVIATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vv] ...... ' $MGCAMD | sed -e 's/^[Vv] \(..\)\(..\)\(..\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)/V: { \1 \2 \3 \4 { \5 \6 \7 \8 \9 /' -e 's/^V: { \(.. .. .. .. { .. .. .. .. .. \)\(..\)\(..\)\(..\)/V: { \1\2 \3 \4 }}/' -e 's/^V: { \(.. .. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/V: { \1\2/' >> $GBOXVIATMP
  [ ${CORRECTMODE} = 1 ] && cp $GBOXVIATMP $GBOXVIA
}

gbox2mgcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from gbox files" > $MGCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii]: { .. ' $GBOXIRDETOTMP | sed -e 's/^[Ii]: { \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9 /' -e 's/^I 00     \(.. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/I 00     \1;\3/' >> $MGCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss]: { .. ' $GBOXSECATMP | sed -e 's/^[Ss]: { \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1\2   \3 \4\5\6\7\8\9/' -e 's/^S \(....   .. ............\) \(..\) \(..\)/S \1\2\3 /' -e 's/^S \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/S \1;\3/' >> $MGCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vv]: ( .. ' $GBOXVIATMP | sed -e 's/^[Vv]: { \(..\) \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\)/V \1\2\3 \4 \5\6\7\8\9/' -e 's/^V \(...... .. ..........\) \(..\) \(..\) \(..\)/V \1\2\3\4 /' -e 's/^V \(...... .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/V \1;\3/' >> $MGCAMDTMP
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn]: { .. ' $GBOXNAGRATMP | sed -e 's/^[Nn]: { \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1\2   \3 \4\5\6\7\8\9/' -e 's/^N \(....   .. ............\) \(..\) \(..\)/N \1\2\3 /' -e 's/^N \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/N \1;\3/' >> $MGCAMDTMP
  nagraunhack $MGCAMDTMP $MGCAMD
}  

mgcamd2scce()
{
# check for AutoRoll.Key; if exists create nagra_rsa
  if test -f $AUTOROLL
  then
    grep ^N $AUTOROLL > $SCCENAGRARSA
  fi

  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && echo "; File generated by dreamconv.sh from SoftCam.Key file" > $SCCEIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $SCCEIRDETO >> $SCCEIRDETOTMP
grep -e '^[Ii] .. ' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/I: { \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^I: { \(..\) { \(.. .. .. .. .. .. ..\) \(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/I: { \1 { \2 \3 }} #\5/' >> $SCCEIRDETOTMP
  [ ${CORRECTMODE} = 1 ] && mv $SCCEIRDETOTMP $SCCEIRDETO
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && echo "; File generated by dreamconv.sh from SoftCam.Key file" > $SCCESECATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXSECA >> $SCCESECATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/S: { \1 \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^S: { \(.... .. { .. .. .. .. .. .. .. \)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/S: { \1\2 }} #\4/' >> $SCCESECATMP
  [ ${CORRECTMODE} = 1 ] && mv $SCCESECATMP $SCCESECA
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && echo "; File generated by dreamconv.sh from SoftCam.Key file" > $SCCEVIATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $GBOXVIA >> $SCCEVIATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vv] ...... ' $MGCAMD | sed -e 's/^[Vv] \(.....\)\(.\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/V: { \1 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^V: { \(..... .. { .. .. .. .. .. .. \)\(..\)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/V: { \1\2 \3 }} #\5/' >> $SCCEVIATMP
  [ ${CORRECTMODE} = 1 ] && mv $SCCEVIATMP $SCCEVIA
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && echo "; File generated by dreamconv.sh from SoftCam.Key file" > $SCCENAGRATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^MK\?:' $SCCENAGRA >> $SCCENAGRATMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/N: { \1 \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^N: { \(.... .. { .. .. .. .. .. .. .. \)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/N: { \1\2 }} #\4/' >> $SCCENAGRATMP
  [ ${CORRECTMODE} = 1 ] && mv $SCCENAGRATMP $SCCENAGRA
}


scce2mgcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from scce files (ucas)" > $MGCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii]: { .. ' $SCCEIRDETO | sed -e 's/^[Ii]: { \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9 /' -e 's/^I 00     \(.. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/I 00     \1;\3/' >> $MGCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss]: { .... ' $SCCESECA | sed -e 's/^[Ss]: { \(....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1   \2 \3\4\5\6\7\8/' -e 's/^S \(....   .. ............\) \(..\) \(..\)/S \1\2\3 /' -e 's/^S \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/S \1;\3/' >> $MGCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vv]: { ..... ' $SCCEVIA | sed -e 's/^[Vv]: { \(.....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/V \10 \2 \3\4\5\6\7\8/' -e 's/^V \(...... .. ............\) \(..\) \(..\)/V \1\2\3 /' -e 's/^V \(...... .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/V \1;\3/' >> $MGCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn]: { .... ' $SCCENAGRA | sed -e 's/^[Nn]: { \(....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1   \2 \3\4\5\6\7\8/' -e 's/^N \(....   .. ............\) \(..\) \(..\)/N \1\2\3 /' -e 's/^N \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/N \1;\3/' >> $MGCAMDTMP
  nagraunhack $MGCAMDTMP $MGCAMD
}

xcam2mgcamd()
{
andthemodeis init
[ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from Keys.txt (xcam)" > $MGCAMDTMP
andthemodeis irdeto
[ ${CORRECTMODE} = 1 ] && tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[iI].*[kK][eE][yY]" | sed -e "s/[iI]\(......\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[hH][sS][nN]=......^[hH][mM][kK]=....................^[pP][mM][kK]=................^[mM][iI][dD]=\(..\)^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/I 00     \4 \5 ;\6 \2 ID=\1 mid=\3@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
andthemodeis seca
[ ${CORRECTMODE} = 1 ] && tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[sS].*[kK][eE][yY]" | sed -e "s/[sS]\(....\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[uU][aA]=............^[pP][pP][uU][aA]=........^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1   \3 \4 ;\5 \2 @^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
andthemodeis via
[ ${CORRECTMODE} = 1 ] && tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[vV].*[kK][eE][yY]" | sed -e "s/[vV]\(......\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[sS][nN]=..........^[pP][pP][uU][aA]=........^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1 \3 \4 ;\5 \2 @^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
andthemodeis nagra
[ ${CORRECTMODE} = 1 ] && tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[nN].*[kK][eE][yY]" | sed -e "s/[nN]\(....\)]^[nN][aA][zZ][wW][aA]=\([^\^]*\)^[vV][eE][rR][iI][fF][yY]=\([^\^]*\)^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1   \4 \5 ;\6 \2 verify=\3@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
nagraunhack $MGCAMDTMP $MGCAMD
}

evocamd2mgcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from Keylist.txt (evocamd)" > $MGCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] .. ' $EVOCAMD | sed -e 's/^[Ii] \(..\) \(..\) \(................\)\( \?;\?\)\(.*\)/I \1     \2 \3 ; \5/' >> $MGCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $EVOCAMD | sed -e 's/^[Ss] \(....\) \(..\) \(................\)\( \?;\?\)\(.*\)/S \1   \2 \3 ; \5/' >> $MGCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vs] ...... ' $EVOCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\)\( \?;\?\)\(.*\)/V \1 \2 \3 ; \5/' >> $MGCAMDTMP
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $EVOCAMD | sed -e 's/^[Nn] \(....\) \(..\) \(................\)\( \?;\?\)\(.*\)/N \1   \2 \3 ; \5/' >> $MGCAMDTMP
cp $MGCAMDTMP $MGCAMD
}

mgcamd2evocamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; Keylist.txt (evocamd) generated by dreamconv.sh from SoftCam.Key " > $EVOCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] .. ' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(................\)\([ ;]*\)/I \1 \2 \3\4/' >> $EVOCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(................\)\([ ;]*\)/S \1 \2 \3\4/' >> $EVOCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vs] ...... ' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\)\([ ;]*\)/V \1 \2 \3\4/' >> $EVOCAMDTMP
  andthemodeis nagra
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(................\)\([ ;]*\)/N \1 \2 \3\4/' >> $EVOCAMDTMP
cp $EVOCAMDTMP $EVOCAMD
}

newcamd2mgcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from keylist (newcamd)" > $MGCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^17..:......:' $NEWCAMD | sed -e 's/^17..:......:....\(..\):*:\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 10     \1 \2\3\4\5\6\7\8\9/' -e 's/^\(I 10     .. ................\) \?#\?\(.*\)/\1 ;\2/' >> $MGCAMDTMP 
  [ ${CORRECTMODE} = 1 ] && grep -e '^060[02]:' $NEWCAMD | sed -e 's/^060[02]:......:....\(..\):*:\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9/' -e 's/^\(I 00     .. ................\) \?#\?\(.*\)/\1 ;\2/' >> $MGCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^0100:......:' $NEWCAMD | sed -e 's/^0100:..\(....\):....\(..\):*:\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1   \2 \3\4\5\6\7\8\9/' -e 's/^\(S ....   .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^0500:......:' $NEWCAMD | sed -e 's/^0500:\(......\):....\(..\):*:\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/V \1 \2 \3\4\5\6\7\8\9/' -e 's/^\(V ...... .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
  andthemodeis nagra
# do not copy verification keys
  [ ${CORRECTMODE} = 1 ] && grep -e '^1800:......:....0' $NEWCAMD | sed -e 's/^1800:......:\(....\)\(0.\):*:\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1   \2 \3\4\5\6\7\8\9/' -e 's/^\(N ....   .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
mv $MGCAMDTMP $MGCAMD
}

mgcamd2newcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "# keylist (newcamd) generated by dreamconv.sh from SoftCam.Key " > $NEWCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] 10 ' $MGCAMD | sed -e 's/^[Ii] 10     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/1762:000000:0000\1::\2 \3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(17.*\)p_^ \?[ ;]\?\(.*\)/\1 # \2/' >> $NEWCAMDTMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] 00 ' $MGCAMD | sed -e 's/^[Ii] 00     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0602:000000:0000\1::\2 \3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0602.*\)p_^ \?[ ;]\?\(.*\)/\1 # \2/' >> $NEWCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0100:00\1:0000\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0100.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vs] ...... ' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0500:\1:0000\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0500.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
  andthemodeis nagra
# copy verification keys first
  [ ${CORRECTMODE} = 1 ] && grep -e '^1800:......:....[123456789abcdefABCDEF].::' $NEWCAMD >> $NEWCAMDTMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/1800:000000:\1\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(1800.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
# copy freex keys
grep -e '^4a60:' $NEWCAMD >> $NEWCAMDTMP
mv $NEWCAMDTMP $NEWCAMD
}

camd32mgcamd()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "; SoftCam.Key generated by dreamconv.sh from camd.kye (camd3)" > $MGCAMDTMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^17.2:......:' $CAMD3 | sed -e 's/^17.2:......:..........:\(..\):\(................\) \?#\?;\?\(.*\)/I 10     \1 \2 ;\3/' >> $MGCAMDTMP 
  [ ${CORRECTMODE} = 1 ] && grep -e '^060[02]:' $CAMD3 | sed -e 's/^060[02]:......:..........:\(..\):\(................\) \?#\?;\?\(.*\)/I 00     \1 \2 ;\3/' >> $MGCAMDTMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^0100:......:' $CAMD3 | sed -e 's/^0100:..\(....\):..........:\(..\):\(................\) \?#\?;\?\(.*\)/S \1   \2 \3 ;\4/' >> $MGCAMDTMP 
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^0500:......:' $CAMD3 | sed -e 's/^0500:\(......\):..........:\(..\):\(................\) \?#\?;\?\(.*\)/V \1 \2 \3 ;\4/' >> $MGCAMDTMP 
  andthemodeis nagra
# ignore rsakeys
  [ ${CORRECTMODE} = 1 ] && grep -e '^1800:......:..........:0' $CAMD3 | sed -e 's/^1800:..\(....\):..........:\(0.\):\(................\) \?#\?\(.*\)/N \1   \2 \3 ;\4/' >> $MGCAMDTMP 
#nagraunhack $MGCAMDTMP $MGCAMD
rm $MGCAMDTMP $MGCAMD
}

mgcamd2camd3()
{
  andthemodeis init
  [ ${CORRECTMODE} = 1 ] && echo "# camd.key (camd3) generated by dreamconv.sh from SoftCam.Key " > $CAMD3TMP
  andthemodeis irdeto
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] 10 ' $MGCAMD | sed -e 's/^[Ii] 10     \(..\) \(................\) \?[ ;]\?\(.*\)/1722:000000:0000000000:\1:\2 ;\3/'  >> $CAMD3TMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ii] 00 ' $MGCAMD | sed -e 's/^[Ii] 00     \(..\) \(................\) \?[ ;]\?\(.*\)/0602:000000:0000000000:\1:\2 ;\3/' >> $CAMD3TMP
  andthemodeis seca
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Ss] .... ' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(................\) \?[ ;]\?\(.*\)/0100:00\1:0000000000:\2:\3 ;\4/'  >> $CAMD3TMP
  andthemodeis via
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Vs] ...... ' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\) \?[ ;]\?\(.*\)/0500:\1:0000000000:\2:\3 ;\4/' >> $CAMD3TMP
  andthemodeis nagra
# copy verification keys first
  [ ${CORRECTMODE} = 1 ] && grep -e '^1800:......:..........:[123456789abcdefABCDEF].:' $CAMD3 >> $CAMD3TMP
  [ ${CORRECTMODE} = 1 ] && grep -e '^[Nn] .... ' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(................\) \?[ ;]\?\(.*\)/1800:00\1:0000000000:\2:\3 ;\4/' >> $CAMD3TMP
mv $CAMD3TMP $CAMD3
}

nagrahack()
{
# nagravision hispavision provider id hack
# call nagrahack <scce or gbox nagra keyfile>
  #grep -e '^N: { 70' -e '^N: { 40' -e '^N: { 48' $1 | sed -e 's/^N: { 70/N: { 71/' -e 's/^N: { 48/N: { 49/' -e 's/^N: { 40/N: { 41/' >> $1
  sed -e 's/^N: { 70/N: { 71/' -e 's/^N: { 40/N: { 41/' -e 's/^N: { 48/N: { 49/' -e 's/^N: { 78/N: { 74/' $1 > $GBOXNAGRATMP && cp $GBOXNAGRATMP $1
}

nagraunhack()
{
  sed -e 's/^N 71/N 70/' -e 's/^N 41/N 40/' -e 's/^N 49/N 48/' -e 's/^N 74/N 78/' $1 > $2 && cp $2 $1
}

nagrahackmgcamd()
{
# nagravision hispavision provider id hack
# call nagrahack <mgcamd keyfile>
  ##grep -e '^N 70' -e '^N 40' -e '^N 48' $1 | sed -e 's/^N 70/N 71/' -e 's/^N 40/N 41/' -e 's/^N 48/N 49/' >> $1
  sed -e 's/^N 71/N 70/' -e 's/^N 41/N 40/' -e 's/^N 49/N 48/' -e 's/^N 75/N 74/' -e 's/^N 2D/N 2C/' -e 's/^N 6F/N 6E/' -e 's/^N 3D/N 3C/' -e 's/^N C1/N C0/' -e 's/^N 05/N 04/' $1 > $MGCAMDTMP && cp $MGCAMDTMP $1
}
nagrahackkeylist()
{
  sed -e 's/^1800:000000:70010/1800:000000:71010/' -e 's/^1800:000000:40010/1800:000000:41010/' -e 's/^1800:000000:48010/1800:000000:49010/' -e 's/^1800:000000:74010/1800:000000:75010/' -e 's/^1800:000000:2C010/1800:000000:2D010/' -e 's/^1800:000000:6E010/1800:000000:6F010/' -e 's/^1800:000000:3C010/1800:000000:3D010/' -e 's/^1800:000000:C0010/1800:000000:C1010/' -e 's/^1800:000000:04010/1800:000000:05010/' $1 > $NEWCAMDTMP && cp $NEWCAMDTMP $1
}
help()
{
  echo " "
  echo "This script does tricks with dreambox/dbox2 emu keys."
  echo "Usage: $0 <parameter> "
  echo " "
  echo "Where parameter can be:"
  echo "gbox2romu       - convert gbox files to romu files (Ronalds Emu)"
  echo "gbox2scce       - convert gbox files to scce files (Dr. Matrix)"
  echo "gbox2mgcamd     - convert gbox files to mgcamd (softcam.key file)"
  echo "newcamd2mgcamd  - convert newcamd files to mgcamd (softcam.key file)"
  echo "xcam2mgcamd     - convert xcam file to mgcamd (softcam.key file)"
  echo "evocamd2mgcamd  - convert evocamd file to mgcamd (softcam.key file)"
  echo "mgcamd2gbox     - convert mgcamd (softcam.key file) to gbox files"
  echo "mgcamd2romu     - convert mgcamd (softcam.key file) to romu files"
  echo "mgcamd2scce     - convert mgcamd (softcam.key file) to scce files"
  echo "mgcamd2evocamd  - convert mgcamd (softcam.key file) to evocamd (Keylist.txt file)"
  echo "mgcamd2newcamd  - convert mgcamd (softcam.key file) to newcamd (keylist file)"
  echo "mgcamd2camd3    - convert mgcamd (softcam.key file) to camd3 (camd.key file)"
  echo "camd32mgcamd    - convert camd3 (camd.key file) to mgcamd (softcam.key file)"
  echo "romu2gbox       - convert romu files to gbox"
  echo "scce2gbox       - convert scce files to gbox"
  echo "scce2mgcamd     - convert scce files to mgcamd (softcam.key file)"
  echo "nagrahackmgcamd - nagra hack for mgcamd (SoftCam.Key) file"
  echo "nagrahackromu   - nagra hack for romu (nagra_keys) file"
  echo "nagrahackscce   - nagra hack for scce (nagra_keys) file"
  echo "nagrahackgbox   - nagra hack for gbox (nagra) file"
  echo " "
  echo "Parameters are case-sensitive (welcome to Linux :)"
}

# main loop
getconvertmode

case $1 in
	gbox2romu)
		gbox2scce
		nagrahack $SCCENAGRA
		;;
	romu2gbox)
		scce2gbox
		nagrahack $GBOXNAGRA
		;;
	gbox2scce)
		gbox2scce
		nagrahack $SCCENAGRA
		;;
	scce2gbox)
		scce2gbox
		nagrahack $GBOXNAGRA
		;;
	scce2mgcamd)
		scce2mgcamd
		;;
	mgcamd2scce)
		mgcamd2scce
		nagrahack $SCCENAGRA
		;;
	mgcamd2romu)
		mgcamd2scce
		nagrahack $SCCENAGRA
		;;
	mgcamd2gbox)
		mgcamd2gbox
		nagrahack $GBOXNAGRA
		;;
	mgcamd2newcamd)
		mgcamd2newcamd
		nagrahackkeylist $NEWCAMD
		;;
	newcamd2mgcamd)
		newcamd2mgcamd
		nagrahackmgcamd $MGCAMD
		;;
	mgcamd2camd3)
		mgcamd2camd3
#		nagrahack $CAMD3
		;;
	camd32mgcamd)
		camd32mgcamd
		;;
	gbox2mgcamd)
		gbox2mgcamd
		;;
	xcam2mgcamd)
		xcam2mgcamd
		;;
	evocamd2mgcamd)
		evocamd2mgcamd
		;;
	mgcamd2evocamd)
		mgcamd2evocamd
		;;
	nagrahackmgcamd)
		nagrahackmgcamd $MGCAMD
		;;
	nagrahackgbox)
		nagrahack $GBOXNAGRA
		;;
	nagrahackromu)
		nagrahack $SCCENAGRA
		;;
	nagrahackscce)
		nagrahack $SCCENAGRA
		;;
	setconvertmodeall)
		setconvertmode 9
		;;
	setconvertmodenone)
		setconvertmode 0
		;;
	setconvertmodeirdeto)
		setconvertmode 1
		;;
	setconvertmodevia)
		setconvertmode 2
		;;
	setconvertmodeseca)
		setconvertmode 3
		;;
	setconvertmodenagra)
		setconvertmode 4
		;;
	setconvertmodeconax)
		setconvertmode 5
		;;
	*)
		help
		;;
esac

